/*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*!*\

  XML TypeScript Library

  Copyright (c) TypeScriptLibs and Contributors

  Licensed under the MIT License.
  You may not use this file except in compliance with the License.
  You can get a copy of the License at https://typescriptlibs.org/LICENSE.txt

\*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*i*/
/* *
 *
 *  Functions
 *
 * */
export function isDocumentDeclaration(xmlNode) {
    return (isXMLTag(xmlNode) &&
        xmlNode.tag.startsWith('!'));
}
export function isXMLDeclaration(xmlNode) {
    return (isXMLTag(xmlNode) &&
        xmlNode.tag.startsWith('?'));
}
export function isXMLTag(xmlNode) {
    return (xmlNode !== null &&
        typeof xmlNode === 'object' &&
        typeof xmlNode.tag === 'string');
}
